; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 656
WINDOWHEIGHT = 518
IDB_BUTTERFLY1 equ 100
IDB_BUTTERFLY2 equ 101
IDB_BUTTERFLY3 equ 102
object struct ; create a Structure called Object
	tex dd ?; Integer Used To Select Our Texture
	x dd ?; X Position
	y dd ?; Y Position
	z dd ?; Z Position
	yi dd ?; Y Increase Speed (Fall Speed)
	spinz dd ?; Z axis Spin
	spinzi dd ?; Z axis Spin Speed
	flap dd ?; Flapping Triangles :)
	fi dd ?; Flap direction (Increase Value)
object ends
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword
local	BMP:BITMAP
local	hBMP:dword
local	i:dword
local	buf[10]:dword

        mov	hWin,rcx
        xor	ebx,ebx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN
        cmp	edx,WM_TIMER
	je      wmTIMER
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
	invoke	KillTimer,hWin,10
	mov	ecx,obj
	invoke	GlobalFree
	invoke	RtlExitUserProcess,NULL
;----------------------------------------------
wmTIMER:
	invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	

@0:	invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	mov	r8d,milliseconds
	invoke	SetTimer,hWin,10,,0;  #10  25mSec

;-------------------------------------------------------
	mov	edx,offset texture
	invoke	glGenTextures,3; Generate 3 Textures (sizeof(Texture)=3 ID's)
	xor	edi,edi; i<sizeof(Texture; i++)// loop Through all The ID's (bitmap Images)
@1:	mov	edx,res[rdi]
	invoke	LoadImage,IMAGE_BASE,,IMAGE_BITMAP,0,0,LR_CREATEDIBSECTION;
	mov	hBMP,eax
	or	eax,eax;if (hBMP);// does The bitmap Exist?
	jz	@f;		{// If So...
	lea	r8d,BMP
	invoke	GetObject,eax,sizeof BMP; Get The Object
; hBMP: Handle To Graphics Object
; sizeof(BMP): Size of buffer For Object Information
; buffer For Object Information
	invoke	glPixelStorei,GL_UNPACK_ALIGNMENT,4; Pixel Storage Mode (Word alignment/4 bytes)
	mov	edx, texture[rdi]
	invoke	glBindTexture,GL_TEXTURE_2D; bind Our Texture
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR; Linear Filtering
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR; Mipmap Linear Filtering

; Generate Mipmapped Texture (3 bytes, Width, Height and data From The BMP)
	mov	r8d,BMP.bmWidth
	mov	r9d,BMP.bmHeight
	mov	qword ptr [rsp+20h],GL_BGR_EXT
	mov	qword ptr [rsp+28h],GL_UNSIGNED_BYTE
	mov	rax,BMP.mBits
	mov	[rsp+30h],rax
	invoke	gluBuild2DMipmaps,GL_TEXTURE_2D,3

	invoke	DeleteObject,hBMP; delete The bitmap Object
@@:
	add	edi,4
	cmp	edi,3*4;sizeof Texture
	jb	@1

	movss	xmm3,const0_5
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor; (0, 0, 0, 0.5f; black background
	movq	xmm0,constd1
	invoke	glClearDepth;1; depth buffer Setup
	invoke	glDepthFunc,GL_LEQUAL; The Type of depth Testing (Less Or Equal)
	invoke	glDisable,GL_DEPTH_TEST; disable depth Testing
	invoke	glShadeModel,GL_SMOOTH; Select Smooth Shading
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST; Set Perspective calculations To Most accurate
	invoke	glEnable,GL_TEXTURE_2D; Enable Texture Mapping
	invoke	glBlendFunc,GL_ONE,GL_SRC_ALPHA; Set blending Mode (cheap / Quick)
	invoke	glEnable,GL_BLEND; Enable blending

	mov	edx,50*(sizeof object)
        invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED
	mov	obj,eax

	mov	esi,eax
	xor	edi,edi; i<50; i++)// loop To Initialize 50 Objects
@@:	invoke	SetObject; call SetObject To assign New Random Values
	add	edi,(sizeof object)
	cmp	edi,50*(sizeof object)
	jb	@b
        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd1000
	movq	xmm2,constd0_1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd90
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke	BeginPaint
; --------------- Display the scene
;  
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT; clear Screen and depth buffer
	mov	esi,obj
	xor	edi,edi;for (int i=0; i<50; i++)// loop of 50 (draw 50 Objects)
@7:	invoke	glLoadIdentity ; Reset The Modelview Matrix
	mov	ecx,[rdi+rsi].object.tex
	mov	edx,texture[rcx*4]
	invoke	glBindTexture,GL_TEXTURE_2D; bind Our Texture
	movss	xmm2,[rdi+rsi].object.z
	movss	xmm1,[rdi+rsi].object.y	
	movss	xmm0,[rdi+rsi].object.x
	invoke	glTranslatef;(obj[i].x,obj[i].y,obj[i].z; Position The Object
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movss	xmm1,const1
	movss	xmm0,const45
	invoke	glRotatef;45,1,0,0; Rotate On The X-axis
	movss	xmm3,const1
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,[rdi+rsi].object.spinz
	invoke	glRotatef;((obj[i].spinz),0,0,1; Spin On The Z-axis

	invoke	glBegin,GL_TRIANGLES; begin drawing Triangles
;// First Triangle														    _____
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;1,1; 
	xorps	xmm2,xmm2
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glVertex3f; 1, 1, 0
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0,1; 
	movss	xmm2,[rdi+rsi].object.flap
	movss	xmm1,const1
	movss	xmm0,const_1
	invoke	glVertex3f;-1, 1, obj[i].flap
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0,0; 
	xorps	xmm2,xmm2           ;       ______
	movss	xmm1,const_1        ;	(2)|    / (1)
	movss	xmm0,xmm1           ;	   |  /
	invoke	glVertex3f;(-1,-1, 0;	(3)|/

;// Second Triangle
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;(1,1; 
	xorps	xmm2,xmm2
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glVertex3f;( 1, 1, 0;	       
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0,0; 
	xorps	xmm2,xmm2
	movss	xmm1,const_1
	movss	xmm0,xmm1
	invoke	glVertex3f;(-1,-1, 0;	     
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f;(1,0; 
	movss	xmm2,[rdi+rsi].object.flap
	movss	xmm1,const_1                ;          /|(1)
	movss	xmm0,const1                 ;        /  |
	invoke	glVertex3f;( 1,-1, obj[i].flap;	(2)/____|(3)

	invoke	glEnd; done drawing Triangles

	movss	xmm0,[rdi+rsi].object.y
	subss	xmm0,[rdi+rsi].object.yi
	movss	[rdi+rsi].object.y,xmm0;obj[i].y-=obj[i].yi; Move Object down The Screen

        movss	xmm0,[rdi+rsi].object.spinz
	addss	xmm0,[rdi+rsi].object.spinzi
        movss	[rdi+rsi].object.spinz,xmm0;obj[i].spinz+=obj[i].spinzi; Increase Z Rotation by spinzi

        movss	xmm0,[rdi+rsi].object.flap
	addss	xmm0,[rdi+rsi].object.fi
        movss	[rdi+rsi].object.flap,xmm0;obj[i].flap+=obj[i].fi; Increase flap Value by fi

	movss	xmm0,[rdi+rsi].object.y
	comiss	xmm0,const_18
	jnb	@f;if (obj[i].y<-18.0f)	; is Object off The Screen?
	invoke	SetObject;,i; If So, Reassign New Values
@@:	movss	xmm0,[rdi+rsi].object.flap
	comiss	xmm0,const1
	ja	@f
	comiss	xmm0,const_1
	jnb	@6;if ((obj[i].flap>1) || (obj[i].flap<-1))// Time To change Flap direction?
@@:	xor	[rdi+rsi].object.fi,80000000h;obj[i].fi=-obj[i].fi; change direction by Making fi = -fi
@6:	add	edi,sizeof object
	cmp	edi,50*sizeof object
	jb	@7
	invoke	glFlush ; Flush The GL Rendering Pipeline
;   
@4:	invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke  EndPaint,hWin
wmBYE:	leave
	retn	
WndProc	endp
SetObject proc; Sets The Initial Value of Each Object (Random)
	enter	30h,0

	invoke	rand
	mov	ecx,3
	xor	edx,edx
	div	ecx
	mov	[rdi+rsi].object.tex,edx;obj[loop].tex=rand()%3; Texture can be One of 3 Textures
	invoke	rand
	mov	ecx,34
	xor	edx,edx
	div	ecx
	cvtsi2ss xmm0,edx
	subss	xmm0,const17
	movss	[rdi+rsi].object.x,xmm0;obj[loop].x=rand()%34-17.0f; Random x Value From -17.0f To 17.0f
	movr	dword ptr [rdi+rsi].object.y,18.0;obj[loop].y=18.0f; Set y Position To 18 (off Top of Screen)
	invoke	rand
	mov	ecx,30000
	xor	edx,edx
	div	ecx
	cvtsi2ss xmm0,edx
	divss	xmm0,const_1000
	addss	xmm0,const10
	movss	[rdi+rsi].object.z,xmm0;obj[loop].z=-((rand()%30000/1000.0f)+10.0f; z is a Random Value From -10.0f To -40.0f
	invoke	rand
	mov	ecx,10000
	xor	edx,edx
	div	ecx
	cvtsi2ss xmm0,edx
	divss	xmm0,const5000
	subss	xmm0,const1
	movss	[rdi+rsi].object.spinzi,xmm0;obj[loop].spinzi=(rand()%10000)/5000.0f-1; spinzi is a Random Value From -1 To 1
	and	[rdi+rsi].object.flap,0;obj[loop].flap=0; flap Starts off at 0
	invoke	rand
	mov	ecx,100
	xor	edx,edx
	div	ecx
	cvtsi2ss xmm0,edx
	divss	xmm0,const1000
	addss	xmm0,const0_05
	movss	[rdi+rsi].object.fi,xmm0;obj[loop].fi=0.05f+(rand()%100)/1000.0f; fi is a Random Value From 0.05f To 0.15f
	invoke	rand
	mov	ecx,1000
	xor	edx,edx
	div	ecx
	cvtsi2ss xmm0,edx
	divss	xmm0,const10000
	addss	xmm0,const0_001
	movss	[rdi+rsi].object.yi,xmm0;obj[loop].yi=0.001f+(rand()%1000)/10000.0f; yi is a Random Value From 0.001f To 0.101f
	leave
	ret
SetObject endp
;---------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;color bits Ignored
  	cAlphaBits        db	0;No alpha buffer
  	cAlphaShift       db	0;Shift bit Ignored
  	cAccumBits        db	0;No accumulation buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;accumulation bits Ignored
  	cDepthBits        db	16;16bit Z-buffer (depth buffer)
  	cStencilBits      db	0;No Stencil buffer
  	cAuxBuffers       db	0;No auxiliary buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson #38 - resource File Tutorial",0
FileName	db "br_Rabbit3.cur",0
milliseconds	dd 25
texture		dd 3 dup(?)
obj		dd ?;object 50 dup(<>)
res		dd IDB_BUTTERFLY1,IDB_BUTTERFLY2,IDB_BUTTERFLY3
;-----------------------------
;float
const0_001	dd 0.001
const0_05	dd 0.05
const0_5	dd 0.5
const1		dd 1.0
const_1		dd -1.0
const10		dd 10.0
const17		dd 17.0
const_18	dd -18.0
const45		dd 45.0
const1000	dd 1000.0
const_1000	dd -1000.0
const5000	dd 5000.0
const10000	dd 10000.0
;double
constd0_1	dq 0.1
constd1		dq 1.0
constd90	dq 90.0
constd1000	dq 1000.0
end